#ifndef _MWheel_H_
#define _MWheel_H_

//#include <inttypes.h>

#ifdef __cplusplus
extern "C" {
#endif

#define MWHL_COOKIE 0x4d57484c

typedef struct
{
	uint16_t	mwhl_version;
	char*		mwhl_info;
	int16_t		(*mwhl_wheeled)(int16_t Value[16]);
	int16_t		(*mwhl_service)(int32_t Opcode, ...);
				#define MWHL_MOVE_MOUSE						0x02			/*  MWHL_Service(MWHL_MOVE_MOUSE, WORD X, WORD Y)				*/
				#define MWHL_SET_BUTTON						0x03			/*  MWHL_Service(MWHL_SET_BUTTON, WORD Mask, WORD Button)	*/
				#define MWHL_SEND_PACKED					0x04			/*  MWHL_Service(MWHL_SET_BUTTON, WORD Mask, WORD Button)	*/

				#define MWHL_SET_INITMODUL					0x10			/*  MWHL_Service(MWHL_SET_INITMODUL, LONG InitFnc)				*/
	uint16_t	mwhl_wheels;
	uint32_t	mwhl_control;
				#define MWHL_EMU_WM_ARROWED					0x00000001
				#define MWHL_SCROLL_DESKTOP					0x00000002
				#define MWHL_EMU_MU_KEYBD					0x00000004	/* ab v1.5  */
				#define MWHL_SECOND_WHEEL_WITH_CNTRL		0x00000008	/* ab v2.0  */
				#define MWHL_EMU_MU_KEYBD_SHIFT				0x00010000	/* ab v1.5  */
				#define MWHL_EMU_MU_KEYBD_CNTRL				0x00040000	/* ab v1.5  */
				#define MWHL_MOUSE_SPEEDER					0x00000100	/* ab v1.5  */
				#define MWHL_LEFTHAND						0x00000200	/* ab v1.41 */
				#define MWHL_DOUBLECLICK					0x00000400	/* ab v1.41 */
				#define MWHL_SIGNUM_MODE					0x00000800	/* nur v2.1 */
				#define MWHL_BUTTON_LOCK_MASK				0x7e000000	/* ab v1.41 Fr Buttons dessen LOCK-Bit gesetzt ist wird kein EVNT veranlat */

	uint16_t	mwhl_step[16];
	uint16_t	mwhl_direction;
	uint16_t	mwhl_delay;
	uint16_t	mwhl_clock;
	uint16_t	mwhl_sections;
				#define MAX_SECTIONS 8
	uint16_t	mwhl_sectionclock;
/* ab Version 1.5	 */
	uint16_t	mwhl_button_set;
	uint16_t	mwhl_button_clr;
	uint16_t	mwhl_speeder_sw[6];
	uint16_t	mwhl_speeder_sf[6];
}MWHL_Cookie;

#define MICE_COOKIE 0x4D494345

typedef struct {
	uint16_t	version;
	uint16_t	subversion;
	char*		info;
	uint16_t	api_version;
	int32_t		(*action)(uint32_t opcode, ...);
} MICE_Cookie;

typedef enum {
	MICE_SEND_PACKAGE = 0, // action(MICE_SEND_PACKAGE, uint32_t ButtonMask, uint32_t Buttons, int32_t MouseX, int32_t MouseY, int32_t VerticalWheel, int32_t HorizontalWheel)
} MICE_CookieOpcode;

#ifdef __cplusplus
}
#endif


#endif  /* _MWheel_H_ */
