|
| Low level and interrupt routines for the USB mouse driver
|

#ifdef TOSONLY
	.globl _old_ikbd_int
	.globl _interrupt_ikbd
	.globl _mouse_int
	.globl _set_old_int_lvl

	.text

	dc.l	0x58425241		| XBRA
	dc.l	0x534d5343		| _USB
_old_ikbd_int:
	ds.l	1
_interrupt_ikbd:
	tas	lock
	bne	skip
	movem.l	a0-a7/d0-d7,-(sp)
	move.l	a7,oldSP
	lea	ourSP,a7
	bsr	_mouse_int
	move.l	oldSP,a7
	movem.l	(sp)+,a0-a7/d0-d7
	clr.w	lock
skip:	move.l	_old_ikbd_int(PC),-(sp)
	rts
#endif




#ifndef TOSONLY

	.globl _vdi_buttons
	.globl _old_vdi_btnv
	.globl _vdi_btnv

_vdi_buttons:
	dc.l	0
	dc.l	0x58425241		| XBRA
	dc.l	0x534d5343		| _USB
_old_vdi_btnv:
	ds.l	1
_vdi_btnv:
	or.l _vdi_buttons(pc), d0 | merge buttons 3-5 with 1-2
	move.l	_old_vdi_btnv(pc), -(sp)
	rts

	.globl _send_wheel
	.globl _vdi_wheelv
_vdi_wheelv:
	dc.l	simple_rts
_send_wheel:
	move.w 4(sp), d0
	move.w 6(sp), d1
	move.l	_vdi_wheelv(pc), -(sp)
simple_rts:
	rts


	.globl _old_trap2
	.globl _trap2
	dc.l	0x58425241		| XBRA
	dc.l	0x534d5343		| _USB
_old_trap2:
	ds.l	1
_trap2:
	cmpi.w	#115, d0
	bne.s	trap2_call_orig

	move.l a0, -(sp)		| save A0
	move.l d1, a0			| VDIPB
	move.l (a0), a0			| VDI contrl
#ifdef __mcoldfire__
	move.l d0, -(sp)
	move.w (a0), d0
	cmpi.w #125, d0
#else
	cmpi.w #125, (a0)		| vex_butv
#endif
	bne.s test_vex_wheelv

	#ifdef __mcoldfire__
	move.l _old_vdi_btnv(pc), d0
	move.l d0, 18(a0)
	move.l 14(a0), d0
	move.l d0, _old_vdi_btnv
#else
	move.l _old_vdi_btnv(pc), 18(a0)
	move.l 14(a0), _old_vdi_btnv
#endif
#ifdef __mcoldfire__
	move.l (sp)+, d0
#endif
	move.l (sp)+, a0
	rte

test_vex_wheelv:
#ifdef __mcoldfire__
	cmpi.w #134, d0			| vex_wheelv
	bne.s trap2_call_orig_restore_regs
	move.l _vdi_wheelv(pc), d0
	move.l d0, 18(a0)
	move.l 14(a0), d0
	move.l d0, _vdi_wheelv
#else
	cmpi.w #134, (a0)		| vex_wheelv
	bne.s trap2_call_orig_restore_regs
	move.l _vdi_wheelv(pc), 18(a0)
	move.l 14(a0), _vdi_wheelv
#endif
trap2_call_orig_restore_regs:
#ifdef __mcoldfire__
	move.l (sp)+, d0
#endif
	move.l (sp)+, a0
trap2_call_orig:
	move.l	_old_trap2(pc), -(sp)
	rts

#endif // !TOSONLY

	.globl _send_packet
	.globl _fake_hwint

_send_packet:
	lea	-60(sp),sp
	movem.l	d0-a6,(sp)
	move.l	64(sp),a2
	move.l	68(sp),a0
	move.l	72(sp),a1
	jsr	(a2)
	movem.l	(sp),d0-a6
	lea	60(sp),sp
	rts


| wake screen saver
_fake_hwint:
#ifndef __mcoldfire__
	tst.w	0x59e.w
	beq	shortframe
	move.w	#0x118,-(sp)
shortframe:
	pea	retaddr(pc)
	move	sr,d0
	move.w	d0,-(sp)
	move.l	0x118,a0
	jmp	(a0)
retaddr:
#endif
	rts

	.bss
lock:	ds.w 1
oldSP:	ds.l 1
	ds.l 1024
ourSP:
	.end
